# -*- encoding: utf-8 -*-
# stub: chef_data_region 1.0.6 ruby lib

Gem::Specification.new do |s|
  s.name = "chef_data_region".freeze
  s.version = "1.0.6"

  s.required_rubygems_version = Gem::Requirement.new(">= 0".freeze) if s.respond_to? :required_rubygems_version=
  s.require_paths = ["lib".freeze]
  s.authors = ["Someone".freeze]
  s.date = "2018-04-24"
  s.description = "# Chef Data Region\n\n## Description\n\nChef Data Region extends the `Chef::DSL::DataQuery` module's\n`data_bag_item` method with the ability to dynamically expand the data\nbag name in a configurable, environment-specific manner.\n\n## Motivation\n\nThis gem exists to address the following scenario:\n\nAn organization maintains data in Chef data bag items. The data is\ndeployed to several data center environments and is stored in data\nbags whose names reference the environments. The organization wants to\nwrite environment-agnostic recipes that access the data bags without\nexplicitly referencing the data bags by their environment names.\n\nAs a concrete example, imagine the organization maintains encrypted\ndata for three deployment environments: development, staging, and\nproduction. It maintains this data in three data bags, one for each\nenvironment, with data for services named `gadget` and `widget` in\nitems:\n\n    | Environment | Bag            | Item   |\n    |-------------+----------------+--------|\n    | Development | secure-dev     | gadget |\n    | Development | secure-dev     | widget |\n    | Production  | secure-prod    | gadget |\n    | Production  | secure-prod    | widget |\n    | Staging     | secure-staging | gadget |\n    | Staging     | secure-staging | widget |\n\nThe items are encrypted with a key unique to that environment to\nmaximize security.\n\nNow consider how a recipe would access these bags. When then recipe is\nrunning, it needs to know the data center environment in order to\nconstruct the bag name. The organization would most likely assign the\nenviroment name to a node attribute. In a naive implementation, each\nrecipe would include logic that examined the attribute's value to\ndetermine which bag to load. This would obviously duplicate code.\n\nImagine instead that the organization wants to reference the bag by\nthe name `secure` and rely on an _abstraction_ to translate `secure`\ninto the environment-specific bag name.\n\nThis gem provides that abstraction.\n\n## Features\n\nThis gem overrides the `data_bag_item` method with configurable logic\nthat dynamically decides which bag to load. It retains API\ncompatibility with `Chef::DSL::DataQuery#data_bag_item`, so existing\nrecipes that call `data_bag_item` work without modification.\n\nThe gem imposes no constraints on data bag item structure.\n\n## Configuration\n\nAssign the region name to a node attribute that varies by environment:\n\n    node.default['local'][region'] = 'staging'\n\nAdd the following configuration to Chef Client's `client.rb` file.\n\n  * Require the gem:\n\n        require 'chef/data_region'\n\n  * Configure the gem with a hash that maps a bag name to an expansion\n    pattern:\n\n        Chef::DataRegion.add(\n          'secure',\n          { attribute: %w(local region), pattern: 'secure-%<attribute>s' }\n        )\n\n## Bag name expansion\n\nThe gem expands bag names using Ruby's `format` method.\n\n_More pending..._\n".freeze
  s.email = "s@me.one".freeze
  s.homepage = "https://so.me.one".freeze
  s.licenses = ["0BSD".freeze]
  s.rubygems_version = "3.2.22".freeze
  s.summary = "Access region-specific Chef data bags".freeze

  s.installed_by_version = "3.2.22" if s.respond_to? :installed_by_version

  if s.respond_to? :specification_version then
    s.specification_version = 4
  end

  if s.respond_to? :add_runtime_dependency then
    s.add_development_dependency(%q<rspec>.freeze, ["~> 3.0"])
    s.add_development_dependency(%q<rubocop>.freeze, ["~> 0.54"])
    s.add_runtime_dependency(%q<chef>.freeze, ["> 11"])
  else
    s.add_dependency(%q<rspec>.freeze, ["~> 3.0"])
    s.add_dependency(%q<rubocop>.freeze, ["~> 0.54"])
    s.add_dependency(%q<chef>.freeze, ["> 11"])
  end
end
